package it.inaf.oats.ia2.tapschemamanager.api;

/**
 * Store the value of an entity property (that corresponds to a column of the
 * mapped table).
 *
 * @author Sonia Zorba {@literal <zorba at oats.inaf.it>}
 */
public interface EntityProperty {

    /**
     * Retrieve the current value.
     */
    <T> T getValue(Class<T> type);

    /**
     * Initialize the value.
     */
    <T> void init(T initialValue);
}
